//////////////////////////////////////////////////////////////////////
// FormulaDropTarget.h : header file
//
// MFC Formula Control - Drag/Drop target implementation
//
// derived from Chris Maunders GridDropTarget <cmaunder@mail.com>
// Copyright (c) 1998-2001. All Rights Reserved.
//
// This code may be used in compiled form in any way you desire. This
// file may be redistributed unmodified by any means PROVIDING it is 
// not sold for profit without the authors written consent, and 
// providing that this notice and the authors name and all copyright 
// notices remains intact. 
//
// An email letting me know how you are using it would be nice as well. 
//
// This file is provided "as is" with no expressed or implied warranty.
// The author accepts no liability for any damage/loss of business that
// this product may cause.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FormulaDropTarget_H__5C610981_BD36_11D1_97CD_00A0243D1382__INCLUDED_)
#define AFX_FormulaDropTarget_H__5C610981_BD36_11D1_97CD_00A0243D1382__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000


#include <afxole.h>

class CFormulaCtrl;

/////////////////////////////////////////////////////////////////////////////
// CFormulaDropTarget command target

class CFormulaDropTarget : public COleDropTarget
{
public:
    CFormulaDropTarget();
    virtual ~CFormulaDropTarget();

// Attributes
public:
    CFormulaCtrl* m_pFormulaCtrl;
    BOOL       m_bRegistered;

// Operations
public:
    BOOL Register(CFormulaCtrl *pFormulaCtrl);
    virtual void Revoke();

    BOOL        OnDrop(CWnd* pWnd, COleDataObject* pDataObject, DROPEFFECT dropEffect, CPoint point);
    DROPEFFECT  OnDragEnter(CWnd* pWnd, COleDataObject* pDataObject, DWORD dwKeyState, CPoint point);
    void        OnDragLeave(CWnd* pWnd);
    DROPEFFECT  OnDragOver(CWnd* pWnd, COleDataObject* pDataObject, DWORD dwKeyState, CPoint point);
    DROPEFFECT  OnDragScroll(CWnd* pWnd, DWORD dwKeyState, CPoint point);

// Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CFormulaDropTarget)
    //}}AFX_VIRTUAL

// Implementation
protected:

    // Generated message map functions
    //{{AFX_MSG(CFormulaDropTarget)
    //}}AFX_MSG

    DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FormulaDropTarget_H__5C610981_BD36_11D1_97CD_00A0243D1382__INCLUDED_)
